#include <reg420.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rtx51tny.h>

#define	SYSTEM					0
#define	ERROR						1
#define	STATE1					2
#define	PEDESTRIAN	3
#define	CLOCK						4
/*
extern void LCD_Init(void);
extern void Delay(unsigned char);
extern void LCD_Write_String(char*);
extern unsigned char Buffer[LCD_Size+1];
*/
struct Time
{
 unsigned char Hod,Min,Sek;
	long int Pocet;
	char Token;
};

struct Time Cas 								= {0,0,0};
struct Time SpickaBegin = {7,30,0};
struct Time SpickaEnd		 = {16,30,0};

enum Stavy {OFF=0, ON=1};

sbit Green_E		=	P1^0;		//Svetla semaforov ....
sbit Orange_E	=	P1^1;
sbit Red_E				=	P1^2;

sbit Green_N		= P1^3;
sbit Orange_N	=	P1^4;
sbit Red_N				=	P1^5;

sbit Green_W		=	P1^6;
sbit Orange_W	=	P1^7;
sbit Red_W				=	P2^0;

sbit Green_S		=	P2^1;
sbit Orange_S	=	P2^2;
sbit Red_S				=	P2^3;

sbit Pedes1			=	P3^0;
sbit Pedes2			=	P3^1;

sbit Orange_PS= P3^2;
sbit Orange_PE=	P3^3;

sbit	Key						=	P3^4;	//Tlacidlo pre chodcov

bit	 Chodci			= OFF;		//Priznak stlacenia tlacidla chodcov pre vetvenie ...

bit Spicka;

const int TimeY = 10;	//Je spicka
const	int TimeN	= 45;	//Nie je spicka

void Clock(void) _task_ CLOCK
{
 code char Time[]={__TIME__};
	sscanf(Time,"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
	Cas.Pocet=(long int)Cas.Hod*3600+Cas.Min*60+Cas.Sek;
 SpickaBegin.Pocet=(long int)SpickaBegin.Hod*3600+SpickaBegin.Min*60+SpickaBegin.Sek;
	SpickaEnd.Pocet=(long int)SpickaEnd.Hod*3600+SpickaEnd.Min*60+SpickaEnd.Sek;
	while(1)
	 {
		 os_wait(K_IVL,100,NULL);
			Cas.Pocet++;
			if((Cas.Pocet>=SpickaBegin.Pocet)&&(Cas.Pocet<=SpickaEnd.Pocet)) Spicka=ON; else Spicka=OFF;
			if(++Cas.Sek==60)
			 {
				 Cas.Sek=0;
					if(++Cas.Min==60)
					 {
						 Cas.Min=0;
							if(++Cas.Hod==24) {Cas.Hod=0; Cas.Pocet=0;}
						}
				}
		}
}

void Pedestrian(void) _task_ PEDESTRIAN
{
 Pedes1=Pedes2=OFF;
	while(1)
	{
	 os_wait(K_TMO,5,NULL);
		if(Key==0) 
		 {
			 os_send_signal(SYSTEM);
				Chodci=ON;
			}	
	}
}

void State1(void) _task_ STATE1
{
	int i;
	Red_N=Red_S=Red_E=Red_W=ON;
	os_wait(K_TMO,250,NULL);
	while(1)
	{
		//------------------------------------------------------------------ 
		if(Chodci==ON)
		 {
			 Pedes1=Pedes2=ON;
				i=TimeN;
				for(i; i>0; i--) os_wait(K_TMO,100,NULL);
				Pedes1=Pedes2=OFF;
				os_wait(K_TMO,250,NULL);			//Cakam 2500ms	
				Chodci=OFF;
			}
		//------------------------------------------------------------------  		
		Red_E=Red_W=OFF;											//Vypinam cervenu v smere E+W
		Orange_E=Orange_W=ON;						//Zapinam oranzovu v smere E+W
		os_wait(K_TMO,250,NULL);			//Cakam 2500ms	
		Orange_E=Orange_W=OFF;					//Vypinam oranzovu v smere E+W
		Green_E=Green_W=ON;        //TimeY sekund bude svietit zelena E+W
		if(Spicka==OFF) i=TimeY; else i=TimeN;
		for(i; i>0; i--) os_wait(K_TMO,100,NULL);
		//------------------------------------------------------------------
		Green_E=Green_W=OFF;       //Vypinam zelenu E+W
		Orange_E=Orange_W=ON;      //Nahadzujem oranzovu E+W
		os_wait(K_TMO,250,NULL);   //Cakam 2500ms
		Orange_E=Orange_W=OFF;     //Vypinam oranzovu E+W
  Red_E=Red_W=ON;												//Nahadzujem cervenu pre E+W
		//------------------------------------------------------------------
		Orange_S=Orange_N=ON;						//Zapinam oranzovu v smere S+N
		Red_S=Red_N=OFF;											//Vypinam cervenu v smere S+N
		os_wait(K_TMO,250,NULL);   //Cakam 2500ms
		Orange_S=Orange_N=OFF;					//Vypinam oranzovu v smere S+N
		Green_S=Green_N=ON;								//Zapinam zelenu v smere S+N
  if(Spicka==OFF) i=TimeY; else i=TimeN;																						//TimeY sekund bude svietit zelena S+N
		for(i; i>0; i--) os_wait(K_TMO,100,NULL);
		Green_S=Green_N=OFF;							//Vypinam zelenu v smere S+N
		Orange_S=Orange_N=ON;						//Zapinam oranzovu v smere S+N
		os_wait(K_TMO,250,NULL);   //Cakam 2500ms
		Orange_S=Orange_N=OFF;					//Vypinam oranzovu v smere S+N
		Red_S=Red_N=ON;												//Zapinam cervenu v smere S
//  if(Spicka==OFF) i=TimeY; else TimeN;																						//TimeY sekund bude svietit cervena S+N
//		for(i; i>0; i--) os_wait(K_TMO,100,NULL);	//???????????
		//------------------------------------------------------------------
		os_wait(K_TMO,250,NULL);
		Red_N=OFF; 																//Vypinam cervenu v smere N
		Orange_N=ON;															//Zapinam oranzovu v smere N
		os_wait(K_TMO,250,NULL);   //Cakam 2500ms
		Orange_N=OFF;														//Vypinam oranzovu v smere N
		Green_N=ON;																//Zapinam zelenu v smere N
  if(Spicka==OFF) i=TimeY; else i=TimeN;																						//TimeY sekund bude svietit zelena S
		for(i; i>0; i--) os_wait(K_TMO,100,NULL);
		Green_N=OFF;															//Vypinam zelenu v smere N
		Orange_N=ON;															//Zapinam oranzovu v smere N
		os_wait(K_TMO,250,NULL);   //Cakam 2500ms
		Orange_N=OFF;														//Vypinam oranzovu v smere N
		Red_N=ON;																		//Zapinam cervenu v smere N
//------------------------------------------------------------------		
	}
}

void Error(void) _task_ ERROR
{
	int i = 5;  //cca. 5 sekund vypnuta krizovatka
	while(1)
	{
	 for(i*=2; i>0; i--)
		{
			Orange_E=Orange_N=Orange_W=Orange_S=ON;
			os_wait(K_TMO,50,NULL);
			Orange_E=Orange_N=Orange_W=Orange_S=OFF;
			os_wait(K_TMO,50,NULL);
		}
  os_create_task(STATE1);
		os_delete_task(ERROR);
	}
}

void System(void) _task_ SYSTEM
{ 
/* 
	LCD_Init();
	putchar('^');
 os_wait(K_TMO,1,NULL);
	putchar(1);
	os_wait(K_TMO,1,NULL);
	strcpy(Buffer,"Krizovatka");
 LCD_Write_String(Buffer);
*/	
	Orange_E=Orange_N=Orange_W=Orange_S=OFF;		//Inicializacia semaforov, vsetko vypinam ...
	Green_E=Green_N=Green_W=Green_S=OFF;
	Red_E=Red_N=Red_W=Red_S=OFF;
	os_create_task(CLOCK);
	os_create_task(ERROR);
	os_create_task(PEDESTRIAN);
 while(1)
 {
	 switch(os_wait(K_TMO+K_SIG,50,NULL))
		 {
			 case TMO_EVENT	:	Orange_PE=~Orange_PE;
																					Orange_PS=~Orange_PS;  //Blikam stale pre pripojenie sa do cesty za zvysenej opatrnosti ....
																					break;
				case	SIG_EVENT	:	Chodci=ON;	break;						//Ak som sa dostal tu, tak je tam chodec a dam vediet aby ho auta pustili ...
			}
 }
}